#!/usr/bin/env python

import sys

[numsocks,numpairs]=[int(x) for x in sys.stdin.readline().split()]
node = [0] + list(map(int, sys.stdin.readline().split()))
edge = [[] for i in range(numsocks+1)]
for i in range(0,numpairs):
   [s,t]=[int(x) for x in sys.stdin.readline().split()]
   edge[s] += [t]
   edge[t] += [s]

numpaints=0

def connected_components(edges):
  visited = set()
  components = []
  for i in range(len(edges)):
    if i not in visited:
      components += [[i]]
      visited.add(i)
      j = 0
      while j < len(components[-1]):
        for k in edges[components[-1][j]]:
          if k not in visited:
            components[-1] += [k]
            visited.add(k)
        j += 1
  return components

for c in connected_components(edge):
  if len(c)==1: #it's an individual
    continue
  color_count={}
  for i in c:
    if node[i] not in color_count:
       color_count[node[i]]=1
    else:
       color_count[node[i]]+=1

  best_col=None
  best_col_c=0
  for col in color_count:
    if color_count[col]>best_col_c:
      best_col=col
      best_col_c=color_count[col]

  for i in c:
    if node[i]!=best_col:
      numpaints+=1

print(numpaints)

