#include <bits/stdc++.h>
using namespace std;

constexpr int max_n=1000;

static int w[max_n];
static bool visited[max_n];
vector<int> edge[max_n];

vector<int> hits;

void dfs(int x){
  visited[x]=true;
  hits.push_back(w[x]);
  for (int y: edge[x]){
    if (not visited[y]){
      dfs(y);
    }
  }
}

int main(){
  int n,m; cin>>n>>m;
  for (int i=0; i<n; i++) cin>>w[i];
  for (int i=0; i<m; i++){
    int a,b; cin>>a>>b; edge[--a].push_back(--b);
  }

  int res=0;
  for (int i=0; i<n; i++)
    if (not visited[i]){
      dfs(i);
      sort(hits.begin(),hits.end());
      int longest=0;
      for (int j=0,k=0; j<hits.size(); j++){
        while (hits[k]!=hits[j]) ++k;
        longest=max(longest,j-k+1);
      }
      res+=hits.size()-longest;
      hits.clear();
    }
  cout<<res<<endl;
}
