#include <bits/stdc++.h>
using namespace std;
typedef long double ld;

struct Com{
  ld x,y;
};
struct Bucket{
  ld angle,empty,full;
};
Bucket b[1<<20];
tuple<ld,ld,int> evts[1<<21];

int main(){
  int n; cin>>n;
  for (int i=0; i<n; i++){
    cin>>b[i].angle>>b[i].empty>>b[i].full;
    b[i].angle*=M_PI/180.L;
    b[i+n]=b[i]; b[i+n].angle+=M_PI*2;
  }

  Com com={};
  for (int i=0; i<n; i++){
    com.x+=b[i].empty*sinl(b[i].angle);
    com.y+=b[i].empty*cosl(b[i].angle);
  }

  for (int i=0; i<2*n; i++){
    evts[i*2+0]={-b[i].angle,     b[i].full-b[i].empty,i};
    evts[i*2+1]={-b[i].angle+M_PI,b[i].empty-b[i].full,i};
  }
  sort(evts,evts+4*n);

  ld res=0.L;
  for (int i=0; i+1<4*n; i++){
    com.x+=get<1>(evts[i])*sinl(b[get<2>(evts[i])].angle);
    com.y+=get<1>(evts[i])*cosl(b[get<2>(evts[i])].angle);

    pair<ld,ld> const a={get<0>(evts[i]),get<0>(evts[i+1])};
    ld u=a.first,v=a.second;
    while (abs(u-v)>1e-9L){
      ld f=(u*2+v)/3;
      ld g=(u+2*v)/3;
      if (cosl(f)*com.x+sinl(f)*com.y>=cosl(g)*com.x+sinl(g)*com.y){
        v=g;
      }else{
        u=f;
      }
    }
    res=max(res,cosl(v)*com.x+sinl(v)*com.y);
  }
  cout.precision(8);
  cout<<fixed<<res<<endl;
}
