#!/usr/bin/env python

import math
import sys

n = int(raw_input())
buckets = []
for i in range(n):
  angle, empty, full = map(float, raw_input().split())
  angle *= math.pi/180
  buckets += [(angle, empty, full-empty)]

centre_of_mass = [0.0, 0.0]
for i in buckets:
  centre_of_mass[0] += math.sin(i[0]) * i[1]
  centre_of_mass[1] += math.cos(i[0]) * i[1]

buckets += [(i[0] + math.pi*2, i[1], i[2]) for i in buckets]

i = 0
j = 0
res = (-1, -math.pi)
while i < n:
  if buckets[j][0] <= buckets[i][0] + math.pi:
    centre_of_mass[0] += math.sin(buckets[j][0]) * buckets[j][2]
    centre_of_mass[1] += math.cos(buckets[j][0]) * buckets[j][2]
    j += 1
  else:
    centre_of_mass[0] -= math.sin(buckets[i][0]) * buckets[i][2]
    centre_of_mass[1] -= math.cos(buckets[i][0]) * buckets[i][2]
    i += 1

  min_angle = -(buckets[i  ][0])
  max_angle = -(buckets[j-1][0])+math.pi

  if min_angle > max_angle:
    continue

  for ternary_search in range(100):
    a = (min_angle * 2 + max_angle) / 3.0
    b = (min_angle + 2 * max_angle) / 3.0
    if centre_of_mass[0]*math.cos(a) + centre_of_mass[1]*math.sin(a) >= \
       centre_of_mass[0]*math.cos(b) + centre_of_mass[1]*math.sin(b):
      max_angle = b
    else:
      min_angle = a

  res = max(res, (centre_of_mass[0]*math.cos(min_angle) + centre_of_mass[1]*math.sin(min_angle), min_angle))

answer = res[1]
while answer < 0: answer += math.pi * 2
print >>sys.stderr, '%.20f' % (answer * 180.0 / math.pi)
print >>sys.stdout, '%.20f' % res[0]
