#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
using namespace std;

int fibonacci[40]={1,1};

int solve(map<int,int> const &m){
  vector<int> v;
  for (map<int,int>::const_iterator it=m.begin(); it!=m.end(); it++){
    v.push_back(it->second);
  }
  sort(v.rbegin(),v.rend());
  int a=0,b=0,res=0;
  for (vector<int>::iterator it=v.begin(); it!=v.end(); it++){
    res+=(*it)*(a+2);
    a+=(not ((++b)%=fibonacci[a]));
  }
  return res;
}

int main(){
  int n; cin>>n;
  vector<int> s(n); for (auto &i: s) cin>>i;

  for (int i=2; i<40; i++) fibonacci[i]=fibonacci[i-1]+fibonacci[i-2];

  int res=0;
  map<int,int> often;
  for (int i=0; i<n; i++){
    ++often[s[i]];
    cout<<solve(often)<<endl;
  }
}

