#!/usr/bin/env python2

from random import randint, seed

megs = 10**7
n = 100

print megs
print n

for i in range(n):
  op = randint(1, 604800)
  cl = randint(1, 604800)
  if op >= cl:
    op, cl = cl, op

  rate = randint(1, 50)
  print op, cl, rate

dist = [[randint(1, 50) if i <> j else 0 for i in range(n)] for j in range(n)]
for i in range(n):
  for j in range(n):
    if dist[j][i] < dist[i][j]:
      dist[i][j] = dist[j][i]
for i in range(n):
  for j in range(n):
    for k in range(n):
      if dist[j][i] + dist[i][k] < dist[j][k]:
        dist[j][k] = dist[j][i] + dist[i][k]

for i in range(n):
  print ' '.join(map(str, dist[i]))
