#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG 
#define D_LOG(x) x
#else 
#define D_LOG(x)
#endif

typedef long long ll;
typedef long double ld;

ll m;
ld f;
ll n;

// return the expected value
ld expected(ll d) {
	return (m - pow(d*f, 2)) / (n-d);
}

// do the search
ld ternary(ll left, ll right) {
	D_LOG(cout<<"left="<<left<<", right="<<right<<"\n";)
	if (left > right) {
		exit(-1);
	}
	switch(right - left) {
		case 0:
			return expected(right);
		case 1:
			return max(expected(left), expected(right));
	}
	// we need to work out the first third, then the second third.
	ll t1 = ((2 * left) + right) / 3;
	ll t2 = (left + (2* right)) / 3;
	D_LOG(cout<<"t1="<<t1<<", t2="<<t2<<"\n";)
	D_LOG(cout<<"ep(t1)="<<expected(t1)<<", ep(t2)="<<expected(t2)<<"\n";)
	return (expected(t1) < expected(t2)) ? ternary(t1+1, right) : ternary(left, t2);
}

int main(){
	// Read in the data.
	cin>>n;
	cin>>m;
	cin>>f;

	D_LOG(cout<<"managed to read in the data\n";)
	D_LOG(cout<<"n="<<n<<", m="<<m<<", f="<<f<<"\n";)
	cout << setprecision(8) << ternary(0,n-1) << "\n";
}