#!/usr/bin/env perl

use strict;
use warnings;

my $n = int($ARGV[0] // 8);
print "$n\n";

my %kings = ();
while (keys %kings < $n) {
  my $i = 1 + int rand $n;
  my $j = 1 + int rand $n;

  my $cluster = int rand 3;
  if ($cluster) {
    $i = 30 + int ($i / 16);
    $j = 30 + int ($j / 16);
  }
  if (abs ($i - $j) <= $n) {
    $kings{"$i $j"} = 1;
  }
}

for my $i (keys %kings) {
  print "$i\n";
}
