#/usr/bin/env python

import argparse
import random
import sys

SALT = '20ZX8asiW3ZLUULXFRz2b4XR'

MAX_N = 10**3

parser = argparse.ArgumentParser()
parser.add_argument('--name', '-f', help="test case name", type=str)
parser.add_argument('--buckets', '-n', help="number of buckets", type=str)
args = parser.parse_args(sys.argv[1:])

random.seed(SALT + (args.name if args.name else ''))
n = int(args.buckets if args.buckets else random.randint(2, MAX_N))

angles = sorted([random.uniform(0, 360) for i in range(n)])

sys.stdout.write('%d\n' % (n))
for i in angles:
  empty = random.randint(1, 5000)
  full = random.randint(empty, 10000)
  sys.stdout.write('%.6f %d %d\n' % (i, empty, full))
