#include <bits/stdc++.h>
using namespace std;

struct Bucket{
  double angle;
  double empty;
  double full;
};

int main(){
  int n; cin>>n;
  vector<Bucket> b(n);
  for (int i=0; i<n; i++){
    cin>>b[i].angle>>b[i].empty>>b[i].full;
    b[i].angle*=M_PI/180.L;
  }
  pair<double, double> res={-1e20L, -1e20L};
  set<double> angles;
  for (int i=0; i<n; i++){
    angles.insert(-b[i].angle+1e-9L);
    angles.insert(-b[i].angle+1e-9L+M_PI);
    angles.insert(-b[i].angle+1e-9L+M_PI*2);
  }
  for (double angle: angles){
    auto nangle=angles.upper_bound(angle);
    if (nangle==angles.end()) continue;

    double cx=0,cy=0;
    for (int j=0; j<n; j++){
      double x=sinl(b[j].angle+angle);
      double y=cosl(b[j].angle+angle);
      if (x>=0){
        cx+=x*b[j].full;
        cy+=y*b[j].full;
      }else{
        cx+=x*b[j].empty;
        cy+=y*b[j].empty;
      }
    }

    double l=0,r=(*nangle)-(angle);
    for (int z=100; z--;){
      double a=(l*2+r)/3.L;
      double b=(l+r*2)/3.L;
      double ax=cx*cosl(a)+cy*sinl(a);
      double bx=cx*cosl(b)+cy*sinl(b);
      if (ax<=bx){
        l=a;
      }else{
        r=b;
      }
    }
    res=max(res,make_pair((double)(cx*cosl(l)+cy*sinl(l)), l+angle));
  }
  long double ans=res.second*180.L/M_PI-360;
  while (ans<0) ans+=360;
  cerr<<fixed<<ans<<endl;
  cout<<fixed<<res.first<<endl;
}
