size(500);
defaultpen(0.8);

// sizes 2, 3, 2, 1
path r = shift(-4.5, 1) * scale(2) * unitcircle;
path s = shift(4.2, 0.6) * scale(2) * unitcircle;
path t = shift(0.2, 3.15) * scale(3) * unitcircle;
path u = shift(-1.8, 0.15) * unitcircle;
path circles[] = {r, s, t, u};
for (int i = 0; i < 4; ++i)
  fill(circles[i], green);

for (int i = 0; i < 4; ++i)
  draw(circles[i], dashed);

pair places[] = {(-6, 0), (6, 0), (0, 6)};
for (int i=0; i<3; ++i)
  dot(places[i]);
