#!/usr/bin/env python
import random
import sys

def generate(n, t, fin):
   fin.write("%d\n%d\n" % (t, n))
   radii = [random.randint(1, (t + 11) / 12) for i in range(n)]
   quants = [random.randint(1, (t + 11) / 12) for i in range(n)]
   for q, r in zip(quants, radii):
    fin.write("%d %d\n" % (r, q))

for i in range(1, 11, 1):
  with open('secret/%d.in' % (i), 'w') as f:
    random.seed(hash('ukiepc2018') ^ i)
    n = random.randint(1, 100)
    t = random.randint(1, 10000)
    generate(n, t, f)
