#include <iostream>
#include <queue>
#include <vector>
#include <array>
#include <algorithm>
#include "math.h"
using namespace std;

#define PI 3.1415926

typedef struct Ball {
	int diameter;
	int sold;
} Ball;

bool compare_ball(Ball a, Ball b) {
	return a.diameter - b.diameter;
}

int main(){
	// Read in the data.
	double t; cin>>t;
	int taped = 0;
	int b; cin>>b;
	vector<Ball> balls;
	for (int i = 0; i < b; ++i) {
		Ball new_ball;
		cin>>new_ball.sold;
		cin>>new_ball.diameter;
		new_ball.diameter*=2;
		balls.push_back(new_ball);
	};

	sort(balls.begin(), balls.end(), compare_ball);

	for (auto c_it = balls.begin(); c_it < balls.end(); c_it++) {
		double circum = PI * (*c_it).diameter;
		double total = circum * (*c_it).sold;
		if (total <= t) {
			taped += (*c_it).sold;
			t -= total;
		} else {
			int left = floor(t / circum);
			taped += left;
			break;
		}
	}

	cout<<taped<<endl;
}
