#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct Cafe{
  ll s,t,rate;
};
vector<Cafe> c;
vector<vector<ll>> dist;

template <class C>
void update(C &m, int i, ll v){
  auto it=m.find(i);
  if (it==m.end())
    m[i]=v;
  else if (v<it->second)
    it->second=v;
}

int main(){
  ll megs,n; cin>>megs>>n;

  c.resize(n);
  for (auto &i: c)
    cin>>i.s>>i.t>>i.rate;

  dist.assign(n,vector<ll>(n));
  for (auto &r: dist)
    for (auto &i: r)
      cin>>i;

  map<ll,unordered_map<ll,ll>> remain;
  for (int i=n; i--;)
    remain[c[i].s][i]=megs;

  while (not remain.empty()){
    ll t=remain.begin()->first;
    for (auto v: remain.begin()->second){
      int i=v.first;
      if (v.second<=0){
        cout<<t<<endl;
        return 0;
      }
      for (int j=n; j--;)
        if (j!=i and c[j].s<=t+dist[i][j] and t+dist[i][j]<=c[j].t)
          update(remain[t+dist[i][j]], j, v.second);
      if (t<c[i].t)
        update(remain[t+1], i, v.second-c[i].rate);
    }
    remain.erase(remain.begin());
  }

  cout<<"impossible"<<endl;
}
