#!/usr/bin/env python

import argparse
import random
import sys

SALT = '20ZX8asiW3ZLUULXFRz2b4XR'

MAX_N = 10**18
MAX_MONEY = 10**18

parser = argparse.ArgumentParser()
parser.add_argument('--name', '-f', help="test case name", type=str)
args = parser.parse_args(sys.argv[1:])

random.seed(SALT + (args.name if args.name else ''))
n = random.randint(1, MAX_N)
money = random.randint(1, MAX_MONEY)
factor = random.uniform(0.00001, 0.001)

sys.stdout.write('%d %d %.9f\n' % (n, money, factor))

