#!/usr/bin/env python

data = raw_input().split()
n = int(data[0])
cash = int(data[1])
factor = float(data[2])

def payout(d):
  return max(0, cash - pow(factor * d, 2))

def chance(d):
  if 0 <= d < n:
    return 1.0 / (n - d)
  else:
    return 0.0

def value(d):
  return payout(d) * chance(d)

lef = 0
rgt = n
while lef < rgt:
  a = (lef*2 + rgt) / 3
  b = (lef + rgt*2) / 3
  if value(a) < value(b):
    lef = a + 1
  else:
    rgt = b

print '%0.20f' % value(lef)
