#!/usr/bin/env python
from sys import exit

s = raw_input()
assert (1 <= len(s) <= 10**6), 's should contain between [1, 10^6] chars'

n = int(raw_input())
assert (1 <= n <= 10**6), 'n should be at most 10^6'

off = 0
dur = len(s)
for i in range(1,1+n):
  a,b = map(int, raw_input().split())
  assert (0 <= a < dur), format('%d-th start %d is out of range' % (i, a))
  assert (1 <= a+b <= dur), format('%d-th end %d is out of range' % (i, b))
  off += a
  dur = b

exit(42)
